package com.fp.armas.task;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.fp.persistence.commondb.PersistenceHelper;
import com.fp.persistence.parmas.soli.TarmSolicitud;
import com.fp.persistence.parmas.soli.TarmSolicitudArmas;
import com.fp.persistence.pgeneral.gene.TgeneParameters;
import com.fp.persistence.pgeneral.gene.TgeneParametersKey;
import com.fp.simple.action.TaskAction;

/**
 * Clase que se encarga de fijar el codigo de empleado asociado a la solicitud en el request campo userId, para asignar
 * una tarea.
 * 
 * @version 2.1
 */
public class VerificarCantidadArmas extends TaskAction {

    /*
     * (non-Javadoc)
     * 
     * @see com.fp.simple.action.TaskAction#assignOwner(com.fp.dto.Request)
     */
    @SuppressWarnings("unchecked")
    @Override
    public void assignOwner(Object pParam) throws Exception {
    	
    	System.out.println("csolicitud");
        HashMap<String, Object> m = (HashMap<String, Object>) pParam;
        Map<String, Object> mrequest = (Map<String, Object>) m.get("request");
        
        if (mrequest.get("csolicitud") == null) {
            return;
        }
        String csolicitud=mrequest.get("csolicitud").toString();
        //datos armas atadas a una solicitud
        List<TarmSolicitud> solicituds = PersistenceHelper.getEntityManager().
        														createQuery("select o from TarmSolicitud o where o.pk=:csolicitud",TarmSolicitud.class)
        														.setParameter("csolicitud", csolicitud)
        														.getResultList();
        //TgeneParameters parametro = TgeneParameters.find(PersistenceHelper.getEntityManager(), new TgeneParametersKey("NUMERO.ARMAS.FLUJO", 1));
        if(solicituds!=null && solicituds.size()>0 && 
        		solicituds.get(0).getNumerocustodios()!=null && solicituds.get(0).getNumerocustodios()>0){//armas.size()>Integer.parseInt(parametro.getNumbervalue().toString())
        	 m.put("requierecustodia","A");
        }else{
        	 m.put("requierecustodia","D");
        }
       
    }

}
